/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM mozISqlResult.idl
 */

#ifndef __gen_mozISqlResult_h__
#define __gen_mozISqlResult_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class mozISqlConnection; /* forward declaration */

class mozISqlResultEnumerator; /* forward declaration */

class mozISqlInputStream; /* forward declaration */


/* starting interface:    mozISqlResult */
#define MOZISQLRESULT_IID_STR "08c220b0-7140-456a-89e9-c94609a7392d"

#define MOZISQLRESULT_IID \
  {0x08c220b0, 0x7140, 0x456a, \
    { 0x89, 0xe9, 0xc9, 0x46, 0x09, 0xa7, 0x39, 0x2d }}

/**
 * The result of an SQL query. Use the enumerate method to retrieve each
 * row.
 *
 * @status UNDER_DEVELOPMENT
 */
class NS_NO_VTABLE mozISqlResult : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(MOZISQLRESULT_IID)

  /**
   * By default, this value is false.
   */
  /* attribute boolean displayNullAsText; */
  NS_IMETHOD GetDisplayNullAsText(PRBool *aDisplayNullAsText) = 0;
  NS_IMETHOD SetDisplayNullAsText(PRBool aDisplayNullAsText) = 0;

  /**
   * The connection used to execute the query
   */
  /* readonly attribute mozISqlConnection connection; */
  NS_IMETHOD GetConnection(mozISqlConnection * *aConnection) = 0;

  /**
   * The SQL query
   */
  /* readonly attribute AString query; */
  NS_IMETHOD GetQuery(nsAString & aQuery) = 0;

  /**
   * The table that was used in the query. If more than one table was used,
   * only the first is returned. 
   */
  /* readonly attribute AString tableName; */
  NS_IMETHOD GetTableName(nsAString & aTableName) = 0;

  /**
   * The number of rows in the result
   */
  /* readonly attribute long rowCount; */
  NS_IMETHOD GetRowCount(PRInt32 *aRowCount) = 0;

  /**
   * The number of columns in the result
   */
  /* readonly attribute long columnCount; */
  NS_IMETHOD GetColumnCount(PRInt32 *aColumnCount) = 0;

  /**
   * Retrieves the name of a column given its index. Indicies start at zero.
   *
   * @param aColumnIndex   the index of the column to return
   * @return               the column name
   */
  /* AString getColumnName (in long aColumnIndex); */
  NS_IMETHOD GetColumnName(PRInt32 aColumnIndex, nsAString & _retval) = 0;

  /**
   * Retrieves the index of a column given its name. If the column does not
   * exist, -1 is returned.
   *
   * @param aColumnName    the column name to return
   * @return               the column index
   */
  /* long getColumnIndex (in AString aColumnName); */
  NS_IMETHOD GetColumnIndex(const nsAString & aColumnName, PRInt32 *_retval) = 0;

  /**
   * column type constants used by |getColumnType|.
   */
  enum { TYPE_STRING = 1 };

  enum { TYPE_INT = 2 };

  enum { TYPE_FLOAT = 3 };

  enum { TYPE_DECIMAL = 4 };

  enum { TYPE_DATE = 5 };

  enum { TYPE_TIME = 6 };

  enum { TYPE_DATETIME = 7 };

  enum { TYPE_BOOL = 8 };

  /**
   * Returns the type of the data in a given column.
   *
   * @param aColumnIndex   the index of the column to return the type of
   * @return               the column type
   */
  /* long getColumnType (in long aColumnIndex); */
  NS_IMETHOD GetColumnType(PRInt32 aColumnIndex, PRInt32 *_retval) = 0;

  /**
   * Returns the type of the data in a given column as a string. This is used
   * as an alternative to using the constants and will return either
   * string, int, float, decimal, date, time, datetime or bool.
   *
   * @param aColumnIndex   the index of the column to return the type of
   * @return               the column type
   */
  /* AString getColumnTypeAsString (in long aColumnIndex); */
  NS_IMETHOD GetColumnTypeAsString(PRInt32 aColumnIndex, nsAString & _retval) = 0;

  /**
   * Returns the maximum number of bytes that are needed to hold a value in a
   * particular column.
   *
   * @param aColumnIndex   the index of the column to return the size of
   * @return               the column size
   */
  /* long getColumnDisplaySize (in long aColumnIndex); */
  NS_IMETHOD GetColumnDisplaySize(PRInt32 aColumnIndex, PRInt32 *_retval) = 0;

  /**
   * Returns an enumerator to enumerator over the returned rows.
   *
   * @return               the row enumerator
   */
  /* mozISqlResultEnumerator enumerate (); */
  NS_IMETHOD Enumerate(mozISqlResultEnumerator **_retval) = 0;

  /**
   * Returns a stream which may be used to return the rows as XML.
   *
   * The XML format is:
   * <?xml version="1.0"?>
   * <document>
   *   <body>
   *     <row>
   *       <cell>value11</cell>
   *       <cell>value12</cell>
   *       ...
   *     </row>
   *   </body>
   * </document>
   *
   * @return               the input stream
   */
  /* mozISqlInputStream open (); */
  NS_IMETHOD Open(mozISqlInputStream **_retval) = 0;

  /**
   * Re-executes the query.
   */
  /* void reload (); */
  NS_IMETHOD Reload(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_MOZISQLRESULT \
  NS_IMETHOD GetDisplayNullAsText(PRBool *aDisplayNullAsText); \
  NS_IMETHOD SetDisplayNullAsText(PRBool aDisplayNullAsText); \
  NS_IMETHOD GetConnection(mozISqlConnection * *aConnection); \
  NS_IMETHOD GetQuery(nsAString & aQuery); \
  NS_IMETHOD GetTableName(nsAString & aTableName); \
  NS_IMETHOD GetRowCount(PRInt32 *aRowCount); \
  NS_IMETHOD GetColumnCount(PRInt32 *aColumnCount); \
  NS_IMETHOD GetColumnName(PRInt32 aColumnIndex, nsAString & _retval); \
  NS_IMETHOD GetColumnIndex(const nsAString & aColumnName, PRInt32 *_retval); \
  NS_IMETHOD GetColumnType(PRInt32 aColumnIndex, PRInt32 *_retval); \
  NS_IMETHOD GetColumnTypeAsString(PRInt32 aColumnIndex, nsAString & _retval); \
  NS_IMETHOD GetColumnDisplaySize(PRInt32 aColumnIndex, PRInt32 *_retval); \
  NS_IMETHOD Enumerate(mozISqlResultEnumerator **_retval); \
  NS_IMETHOD Open(mozISqlInputStream **_retval); \
  NS_IMETHOD Reload(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_MOZISQLRESULT(_to) \
  NS_IMETHOD GetDisplayNullAsText(PRBool *aDisplayNullAsText) { return _to GetDisplayNullAsText(aDisplayNullAsText); } \
  NS_IMETHOD SetDisplayNullAsText(PRBool aDisplayNullAsText) { return _to SetDisplayNullAsText(aDisplayNullAsText); } \
  NS_IMETHOD GetConnection(mozISqlConnection * *aConnection) { return _to GetConnection(aConnection); } \
  NS_IMETHOD GetQuery(nsAString & aQuery) { return _to GetQuery(aQuery); } \
  NS_IMETHOD GetTableName(nsAString & aTableName) { return _to GetTableName(aTableName); } \
  NS_IMETHOD GetRowCount(PRInt32 *aRowCount) { return _to GetRowCount(aRowCount); } \
  NS_IMETHOD GetColumnCount(PRInt32 *aColumnCount) { return _to GetColumnCount(aColumnCount); } \
  NS_IMETHOD GetColumnName(PRInt32 aColumnIndex, nsAString & _retval) { return _to GetColumnName(aColumnIndex, _retval); } \
  NS_IMETHOD GetColumnIndex(const nsAString & aColumnName, PRInt32 *_retval) { return _to GetColumnIndex(aColumnName, _retval); } \
  NS_IMETHOD GetColumnType(PRInt32 aColumnIndex, PRInt32 *_retval) { return _to GetColumnType(aColumnIndex, _retval); } \
  NS_IMETHOD GetColumnTypeAsString(PRInt32 aColumnIndex, nsAString & _retval) { return _to GetColumnTypeAsString(aColumnIndex, _retval); } \
  NS_IMETHOD GetColumnDisplaySize(PRInt32 aColumnIndex, PRInt32 *_retval) { return _to GetColumnDisplaySize(aColumnIndex, _retval); } \
  NS_IMETHOD Enumerate(mozISqlResultEnumerator **_retval) { return _to Enumerate(_retval); } \
  NS_IMETHOD Open(mozISqlInputStream **_retval) { return _to Open(_retval); } \
  NS_IMETHOD Reload(void) { return _to Reload(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_MOZISQLRESULT(_to) \
  NS_IMETHOD GetDisplayNullAsText(PRBool *aDisplayNullAsText) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDisplayNullAsText(aDisplayNullAsText); } \
  NS_IMETHOD SetDisplayNullAsText(PRBool aDisplayNullAsText) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDisplayNullAsText(aDisplayNullAsText); } \
  NS_IMETHOD GetConnection(mozISqlConnection * *aConnection) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetConnection(aConnection); } \
  NS_IMETHOD GetQuery(nsAString & aQuery) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetQuery(aQuery); } \
  NS_IMETHOD GetTableName(nsAString & aTableName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTableName(aTableName); } \
  NS_IMETHOD GetRowCount(PRInt32 *aRowCount) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRowCount(aRowCount); } \
  NS_IMETHOD GetColumnCount(PRInt32 *aColumnCount) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetColumnCount(aColumnCount); } \
  NS_IMETHOD GetColumnName(PRInt32 aColumnIndex, nsAString & _retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetColumnName(aColumnIndex, _retval); } \
  NS_IMETHOD GetColumnIndex(const nsAString & aColumnName, PRInt32 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetColumnIndex(aColumnName, _retval); } \
  NS_IMETHOD GetColumnType(PRInt32 aColumnIndex, PRInt32 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetColumnType(aColumnIndex, _retval); } \
  NS_IMETHOD GetColumnTypeAsString(PRInt32 aColumnIndex, nsAString & _retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetColumnTypeAsString(aColumnIndex, _retval); } \
  NS_IMETHOD GetColumnDisplaySize(PRInt32 aColumnIndex, PRInt32 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetColumnDisplaySize(aColumnIndex, _retval); } \
  NS_IMETHOD Enumerate(mozISqlResultEnumerator **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Enumerate(_retval); } \
  NS_IMETHOD Open(mozISqlInputStream **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Open(_retval); } \
  NS_IMETHOD Reload(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Reload(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class _MYCLASS_ : public mozISqlResult
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_MOZISQLRESULT

  _MYCLASS_();

private:
  ~_MYCLASS_();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(_MYCLASS_, mozISqlResult)

_MYCLASS_::_MYCLASS_()
{
  /* member initializers and constructor code */
}

_MYCLASS_::~_MYCLASS_()
{
  /* destructor code */
}

/* attribute boolean displayNullAsText; */
NS_IMETHODIMP _MYCLASS_::GetDisplayNullAsText(PRBool *aDisplayNullAsText)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP _MYCLASS_::SetDisplayNullAsText(PRBool aDisplayNullAsText)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute mozISqlConnection connection; */
NS_IMETHODIMP _MYCLASS_::GetConnection(mozISqlConnection * *aConnection)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString query; */
NS_IMETHODIMP _MYCLASS_::GetQuery(nsAString & aQuery)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString tableName; */
NS_IMETHODIMP _MYCLASS_::GetTableName(nsAString & aTableName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long rowCount; */
NS_IMETHODIMP _MYCLASS_::GetRowCount(PRInt32 *aRowCount)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long columnCount; */
NS_IMETHODIMP _MYCLASS_::GetColumnCount(PRInt32 *aColumnCount)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* AString getColumnName (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::GetColumnName(PRInt32 aColumnIndex, nsAString & _retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long getColumnIndex (in AString aColumnName); */
NS_IMETHODIMP _MYCLASS_::GetColumnIndex(const nsAString & aColumnName, PRInt32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long getColumnType (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::GetColumnType(PRInt32 aColumnIndex, PRInt32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* AString getColumnTypeAsString (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::GetColumnTypeAsString(PRInt32 aColumnIndex, nsAString & _retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long getColumnDisplaySize (in long aColumnIndex); */
NS_IMETHODIMP _MYCLASS_::GetColumnDisplaySize(PRInt32 aColumnIndex, PRInt32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* mozISqlResultEnumerator enumerate (); */
NS_IMETHODIMP _MYCLASS_::Enumerate(mozISqlResultEnumerator **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* mozISqlInputStream open (); */
NS_IMETHODIMP _MYCLASS_::Open(mozISqlInputStream **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void reload (); */
NS_IMETHODIMP _MYCLASS_::Reload()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_mozISqlResult_h__ */
