/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIModelElementPrivate.idl
 */

#ifndef __gen_nsIModelElementPrivate_h__
#define __gen_nsIModelElementPrivate_h__


#ifndef __gen_nsIXFormsModelElement_h__
#include "nsIXFormsModelElement.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIXFormsControl; /* forward declaration */

class nsISchemaType; /* forward declaration */

class nsIInstanceElementPrivate; /* forward declaration */

class nsIDOMNode; /* forward declaration */

class nsISchemaBuiltinType; /* forward declaration */


/* starting interface:    nsIModelElementPrivate */
#define NS_IMODELELEMENTPRIVATE_IID_STR "bbc19255-4341-45fb-a9dc-23f4add8a7c3"

#define NS_IMODELELEMENTPRIVATE_IID \
  {0xbbc19255, 0x4341, 0x45fb, \
    { 0xa9, 0xdc, 0x23, 0xf4, 0xad, 0xd8, 0xa7, 0xc3 }}

/**
 * Private interface implemented by the model element for other
 * elements to use.
 */
class NS_NO_VTABLE nsIModelElementPrivate : public nsIXFormsModelElement {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IMODELELEMENTPRIVATE_IID)

  /**
   * Called by form control elements when they are bound to or unbound from
   * this model.  These form controls will be refreshed when refresh() is
   * called on the model.
   */
  /* void addFormControl (in nsIXFormsControl control, in nsIXFormsControl parent); */
  NS_IMETHOD AddFormControl(nsIXFormsControl *control, nsIXFormsControl *parent) = 0;

  /* void removeFormControl (in nsIXFormsControl control); */
  NS_IMETHOD RemoveFormControl(nsIXFormsControl *control) = 0;

  /**
   * Notification that an instance element has started or finished loading
   * its instance data.  Model construction cannot complete until all of
   * the instances have loaded their data.
   *
   * The 'uri' parameter for instanceLoadFinished is the uri of @src or
   * @resource on the instance element and is needed to add the uri to
   * the context info if the link fails.
   */
  /* void instanceLoadStarted (); */
  NS_IMETHOD InstanceLoadStarted(void) = 0;

  /* void instanceLoadFinished (in boolean success, in AString uri); */
  NS_IMETHOD InstanceLoadFinished(PRBool success, const nsAString & uri) = 0;

  /**
   * Locate the instance element child with the given id.
   */
  /* nsIInstanceElementPrivate findInstanceElement (in AString id); */
  NS_IMETHOD FindInstanceElement(const nsAString & id, nsIInstanceElementPrivate **_retval) = 0;

  /**
   * Set the value of an instance node.
   *
   * If doRefresh is true, the function will request xforms-recalculate,
   * xforms-revalidate, and xforms-refresh to be dispatched to the model.
   *
   * @param instanceNode      The node to set the value for
   * @param nodeValue         The value to set
   * @param doRefresh         Request value-changed event sequence
   * @param nodeChanged       Return whether the node was actually changed
   */
  /* void setNodeValue (in nsIDOMNode instanceNode, in AString nodeValue, in boolean doRefresh, out boolean nodeChanged); */
  NS_IMETHOD SetNodeValue(nsIDOMNode *instanceNode, const nsAString & nodeValue, PRBool doRefresh, PRBool *nodeChanged) = 0;

  /**
   * Insert a set of nodes underneath an instance node.
   *
   * If doRebuild is true, the function will request
   * xforms-rebuild, xforms-recalculate, xforms-revalidate, and
   * xforms-refresh to be dispatched to the model.
   *
   * @param node               The instance node
   * @param content            Node that holds the contents to insert under
   *                           the instance node
   * @param doRebuild          Request rebuild event sequence
   */
  /* void setNodeContent (in nsIDOMNode node, in nsIDOMNode content, in boolean doRebuild); */
  NS_IMETHOD SetNodeContent(nsIDOMNode *node, nsIDOMNode *content, PRBool doRebuild) = 0;

  /**
   * Validates the instance node against the schemas loaded by the model.
   */
  /* PRBool validateNode (in nsIDOMNode aInstanceNode); */
  NS_IMETHOD ValidateNode(nsIDOMNode *aInstanceNode, PRBool *_retval) = 0;

  enum { SUBMIT_SERIALIZE_NODE = 1U };

  enum { SUBMIT_SKIP_NODE = 2U };

  enum { SUBMIT_ABORT_SUBMISSION = 3U };

  /**
   * Handles an instance data node and returns one of the above 3 values.
   */
  /* unsigned short handleInstanceDataNode (in nsIDOMNode aInstanceDataNode); */
  NS_IMETHOD HandleInstanceDataNode(nsIDOMNode *aInstanceDataNode, PRUint16 *_retval) = 0;

  /**
   * Set MIP states for given control bound to the given bound node.
   * @param aControl          The control
   * @param aBoundNode        The node the control is bound to
   */
  /* void setStates (in nsIXFormsControl aControl, in nsIDOMNode aBoundNode); */
  NS_IMETHOD SetStates(nsIXFormsControl *aControl, nsIDOMNode *aBoundNode) = 0;

  /**
   * Add an instance element to the model's instance list
   * @param aInstanceElement        The instance element to add to the list
   */
  /* void addInstanceElement (in nsIInstanceElementPrivate aInstanceElement); */
  NS_IMETHOD AddInstanceElement(nsIInstanceElementPrivate *aInstanceElement) = 0;

  /**
   * Remove an instance element from the model's instance list
   * @param aInstanceElement        The instance element to remove from the list
   */
  /* void removeInstanceElement (in nsIInstanceElementPrivate aInstanceElement); */
  NS_IMETHOD RemoveInstanceElement(nsIInstanceElementPrivate *aInstanceElement) = 0;

  /**
   * This attribute is set when the model's instance was lazy authored
   */
  /* readonly attribute boolean lazyAuthored; */
  NS_IMETHOD GetLazyAuthored(PRBool *aLazyAuthored) = 0;

  /**
   * This attribute is set when the model handled xforms-ready event
   */
  /* readonly attribute boolean isReady; */
  NS_IMETHOD GetIsReady(PRBool *aIsReady) = 0;

  /**
   * Retrieves the type for an instance data node
   *
   * @param aInstanceData     The instance data node
   * @param aType             The type of the node
   * @param aNSURI            The namespace of the type
   */
  /* void getTypeFromNode (in nsIDOMNode aInstanceData, out AString aType, out AString aNSUri); */
  NS_IMETHOD GetTypeFromNode(nsIDOMNode *aInstanceData, nsAString & aType, nsAString & aNSUri) = 0;

  /**
   * Notification that all of the external message loads have finished loading.
   * Model contstruction cannot complete until all of the external messages
   * have loaded their data.
   */
  /* void messageLoadFinished (); */
  NS_IMETHOD MessageLoadFinished(void) = 0;

  /**
   * Request an xforms-rebuild.
   *
   * If a previous request (of this or one of the 3 following events) is
   * already being handled, the event will be queued, and sent after that. If
   * multiple events are queued, they will be dispatched FIFO order.
   */
  /* void requestRebuild (); */
  NS_IMETHOD RequestRebuild(void) = 0;

  /**
   * Request an xforms-recalculate
   */
  /* void requestRecalculate (); */
  NS_IMETHOD RequestRecalculate(void) = 0;

  /**
   * Request an xforms-revalidate
   */
  /* void requestRevalidate (); */
  NS_IMETHOD RequestRevalidate(void) = 0;

  /**
   * Request an xforms-refresh
   */
  /* void requestRefresh (); */
  NS_IMETHOD RequestRefresh(void) = 0;

  /**
   * Returns true when the model has been notified that the DOMContentLoaded
   * event has been fired on the XForms document.
   */
  /* readonly attribute boolean hasDOMContentFired; */
  NS_IMETHOD GetHasDOMContentFired(PRBool *aHasDOMContentFired) = 0;

  /**
   * Force rebinding (and refreshing) of a control. Also handles rebinding and
   * refreshing of child controls, if necessary.
   *
   * @param control           The control to rebind.
   */
  /* void forceRebind (in nsIXFormsControl control); */
  NS_IMETHOD ForceRebind(nsIXFormsControl *control) = 0;

  /**
    * Determine the type for a form control based on the schema included by
    * this model.
    */
  /* nsISchemaType getTypeForNode (in nsIDOMNode node); */
  NS_IMETHOD GetTypeForNode(nsIDOMNode *node, nsISchemaType **_retval) = 0;

  /**
   * Determine the type for a form control based on the schema included by
   * this model.
   */
  /* nsISchemaType getTypeForControl (in nsIXFormsControl control); */
  NS_IMETHOD GetTypeForControl(nsIXFormsControl *control, nsISchemaType **_retval) = 0;

  /**
   * Return builtin type name for a form control based on the schema included by
   * this model.
   */
  /* AString getBuiltinTypeNameForControl (in nsIXFormsControl control); */
  NS_IMETHOD GetBuiltinTypeNameForControl(nsIXFormsControl *control, nsAString & _retval) = 0;

  /**
   * This function takes an instance data node, finds the type bound to it, and
   * returns the separated out type and namespace URI.  If no type is set for
   * the node, then it returns the defaults: "http://www.w3.org/2001/XMLSchema"
   * and "string"
   */
  /* void getTypeAndNSFromNode (in nsIDOMNode instancenode, out AString type, out AString namespaceURI); */
  NS_IMETHOD GetTypeAndNSFromNode(nsIDOMNode *instancenode, nsAString & type, nsAString & namespaceURI) = 0;

  /**
   * Retrieves the list of datatypes that the original type is derived from
   * or is an extension of
   *
   * @param aType            The original type
   * @param aNamespace       The original namespace URI
   * @param aTypeList        The returned space-delimited list
   *
   * Returns NS_ERROR_XFORMS_UNION_TYPE if a schema union datatype was
   * encounterd while trying to build the type list.  Will also return an
   * error if we encounter a complex type that comes from complex content
   * extension or restriction.
   */
  /* void getDerivedTypeList (in AString aType, in AString aNamespace, out AString aTypeList); */
  NS_IMETHOD GetDerivedTypeList(const nsAString & aType, const nsAString & aNamespace, nsAString & aTypeList) = 0;

  /**
   * Retrieves the primative builtin type that the original type derives from
   *
   * @param aType            The original type
   * @param aBuiltinType     The returned builtin type (defined in nsISchema)
   *
   * Returns NS_ERROR_XFORMS_UNION_TYPE if a schema union datatype was
   * encounterd while trying to build the type list.  Will also return an
   * error if we encounter a complex type that comes from complex content
   * extension or restriction.
   */
  /* void GetRootBuiltinType (in nsISchemaType aType, out unsigned short aBuiltinType); */
  NS_IMETHOD GetRootBuiltinType(nsISchemaType *aType, PRUint16 *aBuiltinType) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIMODELELEMENTPRIVATE \
  NS_IMETHOD AddFormControl(nsIXFormsControl *control, nsIXFormsControl *parent); \
  NS_IMETHOD RemoveFormControl(nsIXFormsControl *control); \
  NS_IMETHOD InstanceLoadStarted(void); \
  NS_IMETHOD InstanceLoadFinished(PRBool success, const nsAString & uri); \
  NS_IMETHOD FindInstanceElement(const nsAString & id, nsIInstanceElementPrivate **_retval); \
  NS_IMETHOD SetNodeValue(nsIDOMNode *instanceNode, const nsAString & nodeValue, PRBool doRefresh, PRBool *nodeChanged); \
  NS_IMETHOD SetNodeContent(nsIDOMNode *node, nsIDOMNode *content, PRBool doRebuild); \
  NS_IMETHOD ValidateNode(nsIDOMNode *aInstanceNode, PRBool *_retval); \
  NS_IMETHOD HandleInstanceDataNode(nsIDOMNode *aInstanceDataNode, PRUint16 *_retval); \
  NS_IMETHOD SetStates(nsIXFormsControl *aControl, nsIDOMNode *aBoundNode); \
  NS_IMETHOD AddInstanceElement(nsIInstanceElementPrivate *aInstanceElement); \
  NS_IMETHOD RemoveInstanceElement(nsIInstanceElementPrivate *aInstanceElement); \
  NS_IMETHOD GetLazyAuthored(PRBool *aLazyAuthored); \
  NS_IMETHOD GetIsReady(PRBool *aIsReady); \
  NS_IMETHOD GetTypeFromNode(nsIDOMNode *aInstanceData, nsAString & aType, nsAString & aNSUri); \
  NS_IMETHOD MessageLoadFinished(void); \
  NS_IMETHOD RequestRebuild(void); \
  NS_IMETHOD RequestRecalculate(void); \
  NS_IMETHOD RequestRevalidate(void); \
  NS_IMETHOD RequestRefresh(void); \
  NS_IMETHOD GetHasDOMContentFired(PRBool *aHasDOMContentFired); \
  NS_IMETHOD ForceRebind(nsIXFormsControl *control); \
  NS_IMETHOD GetTypeForNode(nsIDOMNode *node, nsISchemaType **_retval); \
  NS_IMETHOD GetTypeForControl(nsIXFormsControl *control, nsISchemaType **_retval); \
  NS_IMETHOD GetBuiltinTypeNameForControl(nsIXFormsControl *control, nsAString & _retval); \
  NS_IMETHOD GetTypeAndNSFromNode(nsIDOMNode *instancenode, nsAString & type, nsAString & namespaceURI); \
  NS_IMETHOD GetDerivedTypeList(const nsAString & aType, const nsAString & aNamespace, nsAString & aTypeList); \
  NS_IMETHOD GetRootBuiltinType(nsISchemaType *aType, PRUint16 *aBuiltinType); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIMODELELEMENTPRIVATE(_to) \
  NS_IMETHOD AddFormControl(nsIXFormsControl *control, nsIXFormsControl *parent) { return _to AddFormControl(control, parent); } \
  NS_IMETHOD RemoveFormControl(nsIXFormsControl *control) { return _to RemoveFormControl(control); } \
  NS_IMETHOD InstanceLoadStarted(void) { return _to InstanceLoadStarted(); } \
  NS_IMETHOD InstanceLoadFinished(PRBool success, const nsAString & uri) { return _to InstanceLoadFinished(success, uri); } \
  NS_IMETHOD FindInstanceElement(const nsAString & id, nsIInstanceElementPrivate **_retval) { return _to FindInstanceElement(id, _retval); } \
  NS_IMETHOD SetNodeValue(nsIDOMNode *instanceNode, const nsAString & nodeValue, PRBool doRefresh, PRBool *nodeChanged) { return _to SetNodeValue(instanceNode, nodeValue, doRefresh, nodeChanged); } \
  NS_IMETHOD SetNodeContent(nsIDOMNode *node, nsIDOMNode *content, PRBool doRebuild) { return _to SetNodeContent(node, content, doRebuild); } \
  NS_IMETHOD ValidateNode(nsIDOMNode *aInstanceNode, PRBool *_retval) { return _to ValidateNode(aInstanceNode, _retval); } \
  NS_IMETHOD HandleInstanceDataNode(nsIDOMNode *aInstanceDataNode, PRUint16 *_retval) { return _to HandleInstanceDataNode(aInstanceDataNode, _retval); } \
  NS_IMETHOD SetStates(nsIXFormsControl *aControl, nsIDOMNode *aBoundNode) { return _to SetStates(aControl, aBoundNode); } \
  NS_IMETHOD AddInstanceElement(nsIInstanceElementPrivate *aInstanceElement) { return _to AddInstanceElement(aInstanceElement); } \
  NS_IMETHOD RemoveInstanceElement(nsIInstanceElementPrivate *aInstanceElement) { return _to RemoveInstanceElement(aInstanceElement); } \
  NS_IMETHOD GetLazyAuthored(PRBool *aLazyAuthored) { return _to GetLazyAuthored(aLazyAuthored); } \
  NS_IMETHOD GetIsReady(PRBool *aIsReady) { return _to GetIsReady(aIsReady); } \
  NS_IMETHOD GetTypeFromNode(nsIDOMNode *aInstanceData, nsAString & aType, nsAString & aNSUri) { return _to GetTypeFromNode(aInstanceData, aType, aNSUri); } \
  NS_IMETHOD MessageLoadFinished(void) { return _to MessageLoadFinished(); } \
  NS_IMETHOD RequestRebuild(void) { return _to RequestRebuild(); } \
  NS_IMETHOD RequestRecalculate(void) { return _to RequestRecalculate(); } \
  NS_IMETHOD RequestRevalidate(void) { return _to RequestRevalidate(); } \
  NS_IMETHOD RequestRefresh(void) { return _to RequestRefresh(); } \
  NS_IMETHOD GetHasDOMContentFired(PRBool *aHasDOMContentFired) { return _to GetHasDOMContentFired(aHasDOMContentFired); } \
  NS_IMETHOD ForceRebind(nsIXFormsControl *control) { return _to ForceRebind(control); } \
  NS_IMETHOD GetTypeForNode(nsIDOMNode *node, nsISchemaType **_retval) { return _to GetTypeForNode(node, _retval); } \
  NS_IMETHOD GetTypeForControl(nsIXFormsControl *control, nsISchemaType **_retval) { return _to GetTypeForControl(control, _retval); } \
  NS_IMETHOD GetBuiltinTypeNameForControl(nsIXFormsControl *control, nsAString & _retval) { return _to GetBuiltinTypeNameForControl(control, _retval); } \
  NS_IMETHOD GetTypeAndNSFromNode(nsIDOMNode *instancenode, nsAString & type, nsAString & namespaceURI) { return _to GetTypeAndNSFromNode(instancenode, type, namespaceURI); } \
  NS_IMETHOD GetDerivedTypeList(const nsAString & aType, const nsAString & aNamespace, nsAString & aTypeList) { return _to GetDerivedTypeList(aType, aNamespace, aTypeList); } \
  NS_IMETHOD GetRootBuiltinType(nsISchemaType *aType, PRUint16 *aBuiltinType) { return _to GetRootBuiltinType(aType, aBuiltinType); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIMODELELEMENTPRIVATE(_to) \
  NS_IMETHOD AddFormControl(nsIXFormsControl *control, nsIXFormsControl *parent) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddFormControl(control, parent); } \
  NS_IMETHOD RemoveFormControl(nsIXFormsControl *control) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveFormControl(control); } \
  NS_IMETHOD InstanceLoadStarted(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->InstanceLoadStarted(); } \
  NS_IMETHOD InstanceLoadFinished(PRBool success, const nsAString & uri) { return !_to ? NS_ERROR_NULL_POINTER : _to->InstanceLoadFinished(success, uri); } \
  NS_IMETHOD FindInstanceElement(const nsAString & id, nsIInstanceElementPrivate **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->FindInstanceElement(id, _retval); } \
  NS_IMETHOD SetNodeValue(nsIDOMNode *instanceNode, const nsAString & nodeValue, PRBool doRefresh, PRBool *nodeChanged) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetNodeValue(instanceNode, nodeValue, doRefresh, nodeChanged); } \
  NS_IMETHOD SetNodeContent(nsIDOMNode *node, nsIDOMNode *content, PRBool doRebuild) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetNodeContent(node, content, doRebuild); } \
  NS_IMETHOD ValidateNode(nsIDOMNode *aInstanceNode, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->ValidateNode(aInstanceNode, _retval); } \
  NS_IMETHOD HandleInstanceDataNode(nsIDOMNode *aInstanceDataNode, PRUint16 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->HandleInstanceDataNode(aInstanceDataNode, _retval); } \
  NS_IMETHOD SetStates(nsIXFormsControl *aControl, nsIDOMNode *aBoundNode) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetStates(aControl, aBoundNode); } \
  NS_IMETHOD AddInstanceElement(nsIInstanceElementPrivate *aInstanceElement) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddInstanceElement(aInstanceElement); } \
  NS_IMETHOD RemoveInstanceElement(nsIInstanceElementPrivate *aInstanceElement) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveInstanceElement(aInstanceElement); } \
  NS_IMETHOD GetLazyAuthored(PRBool *aLazyAuthored) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLazyAuthored(aLazyAuthored); } \
  NS_IMETHOD GetIsReady(PRBool *aIsReady) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsReady(aIsReady); } \
  NS_IMETHOD GetTypeFromNode(nsIDOMNode *aInstanceData, nsAString & aType, nsAString & aNSUri) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTypeFromNode(aInstanceData, aType, aNSUri); } \
  NS_IMETHOD MessageLoadFinished(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->MessageLoadFinished(); } \
  NS_IMETHOD RequestRebuild(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->RequestRebuild(); } \
  NS_IMETHOD RequestRecalculate(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->RequestRecalculate(); } \
  NS_IMETHOD RequestRevalidate(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->RequestRevalidate(); } \
  NS_IMETHOD RequestRefresh(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->RequestRefresh(); } \
  NS_IMETHOD GetHasDOMContentFired(PRBool *aHasDOMContentFired) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetHasDOMContentFired(aHasDOMContentFired); } \
  NS_IMETHOD ForceRebind(nsIXFormsControl *control) { return !_to ? NS_ERROR_NULL_POINTER : _to->ForceRebind(control); } \
  NS_IMETHOD GetTypeForNode(nsIDOMNode *node, nsISchemaType **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTypeForNode(node, _retval); } \
  NS_IMETHOD GetTypeForControl(nsIXFormsControl *control, nsISchemaType **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTypeForControl(control, _retval); } \
  NS_IMETHOD GetBuiltinTypeNameForControl(nsIXFormsControl *control, nsAString & _retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBuiltinTypeNameForControl(control, _retval); } \
  NS_IMETHOD GetTypeAndNSFromNode(nsIDOMNode *instancenode, nsAString & type, nsAString & namespaceURI) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTypeAndNSFromNode(instancenode, type, namespaceURI); } \
  NS_IMETHOD GetDerivedTypeList(const nsAString & aType, const nsAString & aNamespace, nsAString & aTypeList) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDerivedTypeList(aType, aNamespace, aTypeList); } \
  NS_IMETHOD GetRootBuiltinType(nsISchemaType *aType, PRUint16 *aBuiltinType) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRootBuiltinType(aType, aBuiltinType); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsModelElementPrivate : public nsIModelElementPrivate
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIMODELELEMENTPRIVATE

  nsModelElementPrivate();

private:
  ~nsModelElementPrivate();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsModelElementPrivate, nsIModelElementPrivate)

nsModelElementPrivate::nsModelElementPrivate()
{
  /* member initializers and constructor code */
}

nsModelElementPrivate::~nsModelElementPrivate()
{
  /* destructor code */
}

/* void addFormControl (in nsIXFormsControl control, in nsIXFormsControl parent); */
NS_IMETHODIMP nsModelElementPrivate::AddFormControl(nsIXFormsControl *control, nsIXFormsControl *parent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeFormControl (in nsIXFormsControl control); */
NS_IMETHODIMP nsModelElementPrivate::RemoveFormControl(nsIXFormsControl *control)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void instanceLoadStarted (); */
NS_IMETHODIMP nsModelElementPrivate::InstanceLoadStarted()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void instanceLoadFinished (in boolean success, in AString uri); */
NS_IMETHODIMP nsModelElementPrivate::InstanceLoadFinished(PRBool success, const nsAString & uri)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIInstanceElementPrivate findInstanceElement (in AString id); */
NS_IMETHODIMP nsModelElementPrivate::FindInstanceElement(const nsAString & id, nsIInstanceElementPrivate **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setNodeValue (in nsIDOMNode instanceNode, in AString nodeValue, in boolean doRefresh, out boolean nodeChanged); */
NS_IMETHODIMP nsModelElementPrivate::SetNodeValue(nsIDOMNode *instanceNode, const nsAString & nodeValue, PRBool doRefresh, PRBool *nodeChanged)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setNodeContent (in nsIDOMNode node, in nsIDOMNode content, in boolean doRebuild); */
NS_IMETHODIMP nsModelElementPrivate::SetNodeContent(nsIDOMNode *node, nsIDOMNode *content, PRBool doRebuild)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* PRBool validateNode (in nsIDOMNode aInstanceNode); */
NS_IMETHODIMP nsModelElementPrivate::ValidateNode(nsIDOMNode *aInstanceNode, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* unsigned short handleInstanceDataNode (in nsIDOMNode aInstanceDataNode); */
NS_IMETHODIMP nsModelElementPrivate::HandleInstanceDataNode(nsIDOMNode *aInstanceDataNode, PRUint16 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setStates (in nsIXFormsControl aControl, in nsIDOMNode aBoundNode); */
NS_IMETHODIMP nsModelElementPrivate::SetStates(nsIXFormsControl *aControl, nsIDOMNode *aBoundNode)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addInstanceElement (in nsIInstanceElementPrivate aInstanceElement); */
NS_IMETHODIMP nsModelElementPrivate::AddInstanceElement(nsIInstanceElementPrivate *aInstanceElement)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeInstanceElement (in nsIInstanceElementPrivate aInstanceElement); */
NS_IMETHODIMP nsModelElementPrivate::RemoveInstanceElement(nsIInstanceElementPrivate *aInstanceElement)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean lazyAuthored; */
NS_IMETHODIMP nsModelElementPrivate::GetLazyAuthored(PRBool *aLazyAuthored)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean isReady; */
NS_IMETHODIMP nsModelElementPrivate::GetIsReady(PRBool *aIsReady)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getTypeFromNode (in nsIDOMNode aInstanceData, out AString aType, out AString aNSUri); */
NS_IMETHODIMP nsModelElementPrivate::GetTypeFromNode(nsIDOMNode *aInstanceData, nsAString & aType, nsAString & aNSUri)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void messageLoadFinished (); */
NS_IMETHODIMP nsModelElementPrivate::MessageLoadFinished()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void requestRebuild (); */
NS_IMETHODIMP nsModelElementPrivate::RequestRebuild()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void requestRecalculate (); */
NS_IMETHODIMP nsModelElementPrivate::RequestRecalculate()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void requestRevalidate (); */
NS_IMETHODIMP nsModelElementPrivate::RequestRevalidate()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void requestRefresh (); */
NS_IMETHODIMP nsModelElementPrivate::RequestRefresh()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean hasDOMContentFired; */
NS_IMETHODIMP nsModelElementPrivate::GetHasDOMContentFired(PRBool *aHasDOMContentFired)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void forceRebind (in nsIXFormsControl control); */
NS_IMETHODIMP nsModelElementPrivate::ForceRebind(nsIXFormsControl *control)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsISchemaType getTypeForNode (in nsIDOMNode node); */
NS_IMETHODIMP nsModelElementPrivate::GetTypeForNode(nsIDOMNode *node, nsISchemaType **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsISchemaType getTypeForControl (in nsIXFormsControl control); */
NS_IMETHODIMP nsModelElementPrivate::GetTypeForControl(nsIXFormsControl *control, nsISchemaType **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* AString getBuiltinTypeNameForControl (in nsIXFormsControl control); */
NS_IMETHODIMP nsModelElementPrivate::GetBuiltinTypeNameForControl(nsIXFormsControl *control, nsAString & _retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getTypeAndNSFromNode (in nsIDOMNode instancenode, out AString type, out AString namespaceURI); */
NS_IMETHODIMP nsModelElementPrivate::GetTypeAndNSFromNode(nsIDOMNode *instancenode, nsAString & type, nsAString & namespaceURI)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getDerivedTypeList (in AString aType, in AString aNamespace, out AString aTypeList); */
NS_IMETHODIMP nsModelElementPrivate::GetDerivedTypeList(const nsAString & aType, const nsAString & aNamespace, nsAString & aTypeList)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void GetRootBuiltinType (in nsISchemaType aType, out unsigned short aBuiltinType); */
NS_IMETHODIMP nsModelElementPrivate::GetRootBuiltinType(nsISchemaType *aType, PRUint16 *aBuiltinType)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIModelElementPrivate_h__ */
