/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIXFormsAccessors.idl
 */

#ifndef __gen_nsIXFormsAccessors_h__
#define __gen_nsIXFormsAccessors_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIDOMNode_h__
#include "nsIDOMNode.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIXFormsAccessors */
#define NS_IXFORMSACCESSORS_IID_STR "74992960-42a9-4479-a1ff-f7f1b37e187a"

#define NS_IXFORMSACCESSORS_IID \
  {0x74992960, 0x42a9, 0x4479, \
    { 0xa1, 0xff, 0xf7, 0xf1, 0xb3, 0x7e, 0x18, 0x7a }}

/**
 * Interface exposing the states of an XForms control.
 *
 * For more information on this interface please see
 * http://developer.mozilla.org/en/docs/XForms:Custom_Controls
 */
class NS_NO_VTABLE nsIXFormsAccessors : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IXFORMSACCESSORS_IID)

  /**
   * Get the value bound to the XForms control.
   */
  /* DOMString getValue (); */
  NS_IMETHOD GetValue(nsAString & _retval) = 0;

  /**
   * Set the value bound to the XForms control.
   */
  /* void setValue (in DOMString value); */
  NS_IMETHOD SetValue(const nsAString & value) = 0;

  /**
   * @see http://www.w3.org/TR/xforms/slice6.html#model-prop-readOnly
   */
  /* boolean isReadonly (); */
  NS_IMETHOD IsReadonly(PRBool *_retval) = 0;

  /**
   * @see http://www.w3.org/TR/xforms/slice6.html#model-prop-relevant
   */
  /* boolean isRelevant (); */
  NS_IMETHOD IsRelevant(PRBool *_retval) = 0;

  /**
   * @see http://www.w3.org/TR/xforms/slice6.html#model-prop-required
   */
  /* boolean isRequired (); */
  NS_IMETHOD IsRequired(PRBool *_retval) = 0;

  /**
   * @see http://www.w3.org/TR/xforms/slice6.html#model-prop-validate
   */
  /* boolean isValid (); */
  NS_IMETHOD IsValid(PRBool *_retval) = 0;

  /**
   * true, if XForms control is bound to a node in a data model.
   */
  /* boolean hasBoundNode (); */
  NS_IMETHOD HasBoundNode(PRBool *_retval) = 0;

  /**
   * Node that the control is bound to in its data model.
   */
  /* nsIDOMNode getBoundNode (); */
  NS_IMETHOD GetBoundNode(nsIDOMNode **_retval) = 0;

  /**
   * Used to set the complete contents of the bound node.  This function is
   * meant to be used like setValue() except that it can be used to set more
   * than just the first textnode contained under the bound node.  If there
   * is nothing contained under aNode, then all children of the bound node
   * will be eliminated.
   *
   * @param aNode         setContent will take the contents of aNode and copy
   *                      them under the control's bound node.
   * @param aForceUpdate  Indicates whether setContent should rebuild,
   *                      recalculate, revalidate and refresh the model that
   *                      this control is bound to prior to returning
   */
  /* void setContent (in nsIDOMNode aNode, in boolean aForceUpdate); */
  NS_IMETHOD SetContent(nsIDOMNode *aNode, PRBool aForceUpdate) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIXFORMSACCESSORS \
  NS_IMETHOD GetValue(nsAString & _retval); \
  NS_IMETHOD SetValue(const nsAString & value); \
  NS_IMETHOD IsReadonly(PRBool *_retval); \
  NS_IMETHOD IsRelevant(PRBool *_retval); \
  NS_IMETHOD IsRequired(PRBool *_retval); \
  NS_IMETHOD IsValid(PRBool *_retval); \
  NS_IMETHOD HasBoundNode(PRBool *_retval); \
  NS_IMETHOD GetBoundNode(nsIDOMNode **_retval); \
  NS_IMETHOD SetContent(nsIDOMNode *aNode, PRBool aForceUpdate); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIXFORMSACCESSORS(_to) \
  NS_IMETHOD GetValue(nsAString & _retval) { return _to GetValue(_retval); } \
  NS_IMETHOD SetValue(const nsAString & value) { return _to SetValue(value); } \
  NS_IMETHOD IsReadonly(PRBool *_retval) { return _to IsReadonly(_retval); } \
  NS_IMETHOD IsRelevant(PRBool *_retval) { return _to IsRelevant(_retval); } \
  NS_IMETHOD IsRequired(PRBool *_retval) { return _to IsRequired(_retval); } \
  NS_IMETHOD IsValid(PRBool *_retval) { return _to IsValid(_retval); } \
  NS_IMETHOD HasBoundNode(PRBool *_retval) { return _to HasBoundNode(_retval); } \
  NS_IMETHOD GetBoundNode(nsIDOMNode **_retval) { return _to GetBoundNode(_retval); } \
  NS_IMETHOD SetContent(nsIDOMNode *aNode, PRBool aForceUpdate) { return _to SetContent(aNode, aForceUpdate); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIXFORMSACCESSORS(_to) \
  NS_IMETHOD GetValue(nsAString & _retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetValue(_retval); } \
  NS_IMETHOD SetValue(const nsAString & value) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetValue(value); } \
  NS_IMETHOD IsReadonly(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsReadonly(_retval); } \
  NS_IMETHOD IsRelevant(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsRelevant(_retval); } \
  NS_IMETHOD IsRequired(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsRequired(_retval); } \
  NS_IMETHOD IsValid(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsValid(_retval); } \
  NS_IMETHOD HasBoundNode(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->HasBoundNode(_retval); } \
  NS_IMETHOD GetBoundNode(nsIDOMNode **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBoundNode(_retval); } \
  NS_IMETHOD SetContent(nsIDOMNode *aNode, PRBool aForceUpdate) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetContent(aNode, aForceUpdate); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsXFormsAccessors : public nsIXFormsAccessors
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIXFORMSACCESSORS

  nsXFormsAccessors();

private:
  ~nsXFormsAccessors();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsXFormsAccessors, nsIXFormsAccessors)

nsXFormsAccessors::nsXFormsAccessors()
{
  /* member initializers and constructor code */
}

nsXFormsAccessors::~nsXFormsAccessors()
{
  /* destructor code */
}

/* DOMString getValue (); */
NS_IMETHODIMP nsXFormsAccessors::GetValue(nsAString & _retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setValue (in DOMString value); */
NS_IMETHODIMP nsXFormsAccessors::SetValue(const nsAString & value)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isReadonly (); */
NS_IMETHODIMP nsXFormsAccessors::IsReadonly(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isRelevant (); */
NS_IMETHODIMP nsXFormsAccessors::IsRelevant(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isRequired (); */
NS_IMETHODIMP nsXFormsAccessors::IsRequired(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isValid (); */
NS_IMETHODIMP nsXFormsAccessors::IsValid(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean hasBoundNode (); */
NS_IMETHODIMP nsXFormsAccessors::HasBoundNode(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIDOMNode getBoundNode (); */
NS_IMETHODIMP nsXFormsAccessors::GetBoundNode(nsIDOMNode **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setContent (in nsIDOMNode aNode, in boolean aForceUpdate); */
NS_IMETHODIMP nsXFormsAccessors::SetContent(nsIDOMNode *aNode, PRBool aForceUpdate)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIXFormsAccessors_h__ */
