/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIXFormsCaseElement.idl
 */

#ifndef __gen_nsIXFormsCaseElement_h__
#define __gen_nsIXFormsCaseElement_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIXFormsCaseElement */
#define NS_IXFORMSCASEELEMENT_IID_STR "28c8c223-ca17-4b58-b3ca-189864eefe32"

#define NS_IXFORMSCASEELEMENT_IID \
  {0x28c8c223, 0xca17, 0x4b58, \
    { 0xb3, 0xca, 0x18, 0x98, 0x64, 0xee, 0xfe, 0x32 }}

/**
 * Interface implemented by the case element.
 */
class NS_NO_VTABLE nsIXFormsCaseElement : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IXFORMSCASEELEMENT_IID)

  /**
   * According to the XForms 1.0 Errata, the "selected" attribute only
   * determines the initial selected state.  This provides
   * access to the initial state of the "selected" attribute, since it can
   * be programmatically changed via the DOM.
   * (see http://www.w3.org/2003/10/REC-xforms-10-20031014-errata.html#E25b)
   */
  /* readonly attribute boolean initialSelectedState; */
  NS_IMETHOD GetInitialSelectedState(PRBool *aInitialSelectedState) = 0;

  /**
   * Used by switch elements to mark case element selected or deselected.
   */
  /* [noscript] void setSelected (in boolean aEnable); */
  NS_IMETHOD SetSelected(PRBool aEnable) = 0;

  /**
   * This should be called by the XBL widget, when it is created.
   */
  /* void widgetAttached (); */
  NS_IMETHOD WidgetAttached(void) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIXFORMSCASEELEMENT \
  NS_IMETHOD GetInitialSelectedState(PRBool *aInitialSelectedState); \
  NS_IMETHOD SetSelected(PRBool aEnable); \
  NS_IMETHOD WidgetAttached(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIXFORMSCASEELEMENT(_to) \
  NS_IMETHOD GetInitialSelectedState(PRBool *aInitialSelectedState) { return _to GetInitialSelectedState(aInitialSelectedState); } \
  NS_IMETHOD SetSelected(PRBool aEnable) { return _to SetSelected(aEnable); } \
  NS_IMETHOD WidgetAttached(void) { return _to WidgetAttached(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIXFORMSCASEELEMENT(_to) \
  NS_IMETHOD GetInitialSelectedState(PRBool *aInitialSelectedState) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetInitialSelectedState(aInitialSelectedState); } \
  NS_IMETHOD SetSelected(PRBool aEnable) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetSelected(aEnable); } \
  NS_IMETHOD WidgetAttached(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->WidgetAttached(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsXFormsCaseElement : public nsIXFormsCaseElement
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIXFORMSCASEELEMENT

  nsXFormsCaseElement();

private:
  ~nsXFormsCaseElement();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsXFormsCaseElement, nsIXFormsCaseElement)

nsXFormsCaseElement::nsXFormsCaseElement()
{
  /* member initializers and constructor code */
}

nsXFormsCaseElement::~nsXFormsCaseElement()
{
  /* destructor code */
}

/* readonly attribute boolean initialSelectedState; */
NS_IMETHODIMP nsXFormsCaseElement::GetInitialSelectedState(PRBool *aInitialSelectedState)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] void setSelected (in boolean aEnable); */
NS_IMETHODIMP nsXFormsCaseElement::SetSelected(PRBool aEnable)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void widgetAttached (); */
NS_IMETHODIMP nsXFormsCaseElement::WidgetAttached()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIXFormsCaseElement_h__ */
