/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIXFormsNSSelectElement.idl
 */

#ifndef __gen_nsIXFormsNSSelectElement_h__
#define __gen_nsIXFormsNSSelectElement_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIDOMNode; /* forward declaration */

class nsIDOMNodeList; /* forward declaration */


/* starting interface:    nsIXFormsNSSelectElement */
#define NS_IXFORMSNSSELECTELEMENT_IID_STR "2740b6ce-a5cc-432d-882e-56290cf6389f"

#define NS_IXFORMSNSSELECTELEMENT_IID \
  {0x2740b6ce, 0xa5cc, 0x432d, \
    { 0x88, 0x2e, 0x56, 0x29, 0x0c, 0xf6, 0x38, 0x9f }}

/**
 * Defines additional post-spec. methods for the xforms:select element.
 */
class NS_NO_VTABLE nsIXFormsNSSelectElement : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IXFORMSNSSELECTELEMENT_IID)

  /**
   * Get array of selected xforms:item elements.
   */
  /* readonly attribute nsIDOMNodeList selectedItems; */
  NS_IMETHOD GetSelectedItems(nsIDOMNodeList * *aSelectedItems) = 0;

  /**
   * Select xforms:item element. If xforms:select element has selected items
   * then selection for them will be saved.
   *
   * @param item - xforms:item element.
   */
  /* void addItemToSelection (in nsIDOMNode item); */
  NS_IMETHOD AddItemToSelection(nsIDOMNode *item) = 0;

  /**
   * Unselect xforms item element. If xforms:select element has other selected
   * items then selection for them will be saved.
   *
   * @param item - xforms:item element.
   */
  /* void removeItemFromSelection (in nsIDOMNode item); */
  NS_IMETHOD RemoveItemFromSelection(nsIDOMNode *item) = 0;

  /**
   * Unselect all selected xforms:item elements.
   */
  /* void clearSelection (); */
  NS_IMETHOD ClearSelection(void) = 0;

  /**
   * Select all xforms:item elements.
   */
  /* void selectAll (); */
  NS_IMETHOD SelectAll(void) = 0;

  /**
   * Check whether given xforms:item element is selected or not.
   *
   * @param item - xforms item element.
   *
   * @return - true if given xforms:item element is selected.
   */
  /* boolean isItemSelected (in nsIDOMNode item); */
  NS_IMETHOD IsItemSelected(nsIDOMNode *item, PRBool *_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIXFORMSNSSELECTELEMENT \
  NS_IMETHOD GetSelectedItems(nsIDOMNodeList * *aSelectedItems); \
  NS_IMETHOD AddItemToSelection(nsIDOMNode *item); \
  NS_IMETHOD RemoveItemFromSelection(nsIDOMNode *item); \
  NS_IMETHOD ClearSelection(void); \
  NS_IMETHOD SelectAll(void); \
  NS_IMETHOD IsItemSelected(nsIDOMNode *item, PRBool *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIXFORMSNSSELECTELEMENT(_to) \
  NS_IMETHOD GetSelectedItems(nsIDOMNodeList * *aSelectedItems) { return _to GetSelectedItems(aSelectedItems); } \
  NS_IMETHOD AddItemToSelection(nsIDOMNode *item) { return _to AddItemToSelection(item); } \
  NS_IMETHOD RemoveItemFromSelection(nsIDOMNode *item) { return _to RemoveItemFromSelection(item); } \
  NS_IMETHOD ClearSelection(void) { return _to ClearSelection(); } \
  NS_IMETHOD SelectAll(void) { return _to SelectAll(); } \
  NS_IMETHOD IsItemSelected(nsIDOMNode *item, PRBool *_retval) { return _to IsItemSelected(item, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIXFORMSNSSELECTELEMENT(_to) \
  NS_IMETHOD GetSelectedItems(nsIDOMNodeList * *aSelectedItems) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSelectedItems(aSelectedItems); } \
  NS_IMETHOD AddItemToSelection(nsIDOMNode *item) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddItemToSelection(item); } \
  NS_IMETHOD RemoveItemFromSelection(nsIDOMNode *item) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveItemFromSelection(item); } \
  NS_IMETHOD ClearSelection(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->ClearSelection(); } \
  NS_IMETHOD SelectAll(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->SelectAll(); } \
  NS_IMETHOD IsItemSelected(nsIDOMNode *item, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsItemSelected(item, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsXFormsNSSelectElement : public nsIXFormsNSSelectElement
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIXFORMSNSSELECTELEMENT

  nsXFormsNSSelectElement();

private:
  ~nsXFormsNSSelectElement();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsXFormsNSSelectElement, nsIXFormsNSSelectElement)

nsXFormsNSSelectElement::nsXFormsNSSelectElement()
{
  /* member initializers and constructor code */
}

nsXFormsNSSelectElement::~nsXFormsNSSelectElement()
{
  /* destructor code */
}

/* readonly attribute nsIDOMNodeList selectedItems; */
NS_IMETHODIMP nsXFormsNSSelectElement::GetSelectedItems(nsIDOMNodeList * *aSelectedItems)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addItemToSelection (in nsIDOMNode item); */
NS_IMETHODIMP nsXFormsNSSelectElement::AddItemToSelection(nsIDOMNode *item)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeItemFromSelection (in nsIDOMNode item); */
NS_IMETHODIMP nsXFormsNSSelectElement::RemoveItemFromSelection(nsIDOMNode *item)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void clearSelection (); */
NS_IMETHODIMP nsXFormsNSSelectElement::ClearSelection()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void selectAll (); */
NS_IMETHODIMP nsXFormsNSSelectElement::SelectAll()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isItemSelected (in nsIDOMNode item); */
NS_IMETHODIMP nsXFormsNSSelectElement::IsItemSelected(nsIDOMNode *item, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIXFormsNSSelectElement_h__ */
