/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIXFormsRepeatElement.idl
 */

#ifndef __gen_nsIXFormsRepeatElement_h__
#define __gen_nsIXFormsRepeatElement_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIXFormsControl; /* forward declaration */

class nsIDOMNode; /* forward declaration */


/* starting interface:    nsIXFormsRepeatElement */
#define NS_IXFORMSREPEATELEMENT_IID_STR "41a0ea05-3fe0-48e8-8c38-96cbb544309c"

#define NS_IXFORMSREPEATELEMENT_IID \
  {0x41a0ea05, 0x3fe0, 0x48e8, \
    { 0x8c, 0x38, 0x96, 0xcb, 0xb5, 0x44, 0x30, 0x9c }}

class NS_NO_VTABLE nsIXFormsRepeatElement : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IXFORMSREPEATELEMENT_IID)

  /**
   * Set the current index, and return new value.
   *
   * @param aIndex            The index
   * @param aIsRefresh        Is this part of a refresh event?
   */
  /* void setIndex (inout unsigned long aIndex, in boolean aIsRefresh); */
  NS_IMETHOD SetIndex(PRUint32 *aIndex, PRBool aIsRefresh) = 0;

  /**
   * The current index.
   */
  /* readonly attribute unsigned long index; */
  NS_IMETHOD GetIndex(PRUint32 *aIndex) = 0;

  /**
   * Deselect current index.
   */
  /* void deselect (); */
  NS_IMETHOD Deselect(void) = 0;

  /**
   * Sets whether the repeat is a parent to nested repeats
   */
  /* attribute boolean isParent; */
  NS_IMETHOD GetIsParent(PRBool *aIsParent) = 0;
  NS_IMETHOD SetIsParent(PRBool aIsParent) = 0;

  /**
   * Set parent repeat (nested repeats)
   */
  /* attribute nsIXFormsRepeatElement parent; */
  NS_IMETHOD GetParent(nsIXFormsRepeatElement * *aParent) = 0;
  NS_IMETHOD SetParent(nsIXFormsRepeatElement * aParent) = 0;

  /**
   * The tree level of this repeat (nested repeats)
   */
  /* attribute unsigned long level; */
  NS_IMETHOD GetLevel(PRUint32 *aLevel) = 0;
  NS_IMETHOD SetLevel(PRUint32 aLevel) = 0;

  /**
   * Set currently selected repeat and index value (nested repeats)
   *
   * @param aCurrentRepeat    The current repeat
   * @param aIndex            The current index value
   */
  /* void setCurrentRepeat (in nsIXFormsRepeatElement aCurrentRepeat, in unsigned long aIndex); */
  NS_IMETHOD SetCurrentRepeat(nsIXFormsRepeatElement *aCurrentRepeat, PRUint32 aIndex) = 0;

  /**
   * Get currently selected repeat row
   *
   * @return                  The current repeat row
   */
  /* nsIDOMNode getCurrentRepeatRow (); */
  NS_IMETHOD GetCurrentRepeatRow(nsIDOMNode **_retval) = 0;

  /**
   * Add user of repeat-index. The control will have Bind() and Refresh()
   * called on it, when the index changes.
   */
  /* void addIndexUser (in nsIXFormsControl aControl); */
  NS_IMETHOD AddIndexUser(nsIXFormsControl *aControl) = 0;

  /**
   * Remove user of repeat-index.
   */
  /* void removeIndexUser (in nsIXFormsControl aControl); */
  NS_IMETHOD RemoveIndexUser(nsIXFormsControl *aControl) = 0;

  /**
   * Informs repeat-index users of index change.
   */
  /* void indexHasChanged (); */
  NS_IMETHOD IndexHasChanged(void) = 0;

  /**
   * Retrieve the starting index for the repeat, that is the index that the
   * repeat is initialized to. It is the "startindex" attribute, corrected to
   * be a valid index value.
   */
  /* unsigned long getStartingIndex (); */
  NS_IMETHOD GetStartingIndex(PRUint32 *_retval) = 0;

  /**
   * Handle insertion of a node, ie. eventually adjust index. Note that the
   * node might not be influencing the repeat, it is the repeat's
   * responsibility to check that.
   *
   * @param node              The node that was inserted
   */
  /* void handleNodeInsert (in nsIDOMNode node); */
  NS_IMETHOD HandleNodeInsert(nsIDOMNode *node) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIXFORMSREPEATELEMENT \
  NS_IMETHOD SetIndex(PRUint32 *aIndex, PRBool aIsRefresh); \
  NS_IMETHOD GetIndex(PRUint32 *aIndex); \
  NS_IMETHOD Deselect(void); \
  NS_IMETHOD GetIsParent(PRBool *aIsParent); \
  NS_IMETHOD SetIsParent(PRBool aIsParent); \
  NS_IMETHOD GetParent(nsIXFormsRepeatElement * *aParent); \
  NS_IMETHOD SetParent(nsIXFormsRepeatElement * aParent); \
  NS_IMETHOD GetLevel(PRUint32 *aLevel); \
  NS_IMETHOD SetLevel(PRUint32 aLevel); \
  NS_IMETHOD SetCurrentRepeat(nsIXFormsRepeatElement *aCurrentRepeat, PRUint32 aIndex); \
  NS_IMETHOD GetCurrentRepeatRow(nsIDOMNode **_retval); \
  NS_IMETHOD AddIndexUser(nsIXFormsControl *aControl); \
  NS_IMETHOD RemoveIndexUser(nsIXFormsControl *aControl); \
  NS_IMETHOD IndexHasChanged(void); \
  NS_IMETHOD GetStartingIndex(PRUint32 *_retval); \
  NS_IMETHOD HandleNodeInsert(nsIDOMNode *node); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIXFORMSREPEATELEMENT(_to) \
  NS_IMETHOD SetIndex(PRUint32 *aIndex, PRBool aIsRefresh) { return _to SetIndex(aIndex, aIsRefresh); } \
  NS_IMETHOD GetIndex(PRUint32 *aIndex) { return _to GetIndex(aIndex); } \
  NS_IMETHOD Deselect(void) { return _to Deselect(); } \
  NS_IMETHOD GetIsParent(PRBool *aIsParent) { return _to GetIsParent(aIsParent); } \
  NS_IMETHOD SetIsParent(PRBool aIsParent) { return _to SetIsParent(aIsParent); } \
  NS_IMETHOD GetParent(nsIXFormsRepeatElement * *aParent) { return _to GetParent(aParent); } \
  NS_IMETHOD SetParent(nsIXFormsRepeatElement * aParent) { return _to SetParent(aParent); } \
  NS_IMETHOD GetLevel(PRUint32 *aLevel) { return _to GetLevel(aLevel); } \
  NS_IMETHOD SetLevel(PRUint32 aLevel) { return _to SetLevel(aLevel); } \
  NS_IMETHOD SetCurrentRepeat(nsIXFormsRepeatElement *aCurrentRepeat, PRUint32 aIndex) { return _to SetCurrentRepeat(aCurrentRepeat, aIndex); } \
  NS_IMETHOD GetCurrentRepeatRow(nsIDOMNode **_retval) { return _to GetCurrentRepeatRow(_retval); } \
  NS_IMETHOD AddIndexUser(nsIXFormsControl *aControl) { return _to AddIndexUser(aControl); } \
  NS_IMETHOD RemoveIndexUser(nsIXFormsControl *aControl) { return _to RemoveIndexUser(aControl); } \
  NS_IMETHOD IndexHasChanged(void) { return _to IndexHasChanged(); } \
  NS_IMETHOD GetStartingIndex(PRUint32 *_retval) { return _to GetStartingIndex(_retval); } \
  NS_IMETHOD HandleNodeInsert(nsIDOMNode *node) { return _to HandleNodeInsert(node); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIXFORMSREPEATELEMENT(_to) \
  NS_IMETHOD SetIndex(PRUint32 *aIndex, PRBool aIsRefresh) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetIndex(aIndex, aIsRefresh); } \
  NS_IMETHOD GetIndex(PRUint32 *aIndex) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIndex(aIndex); } \
  NS_IMETHOD Deselect(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Deselect(); } \
  NS_IMETHOD GetIsParent(PRBool *aIsParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsParent(aIsParent); } \
  NS_IMETHOD SetIsParent(PRBool aIsParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetIsParent(aIsParent); } \
  NS_IMETHOD GetParent(nsIXFormsRepeatElement * *aParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetParent(aParent); } \
  NS_IMETHOD SetParent(nsIXFormsRepeatElement * aParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetParent(aParent); } \
  NS_IMETHOD GetLevel(PRUint32 *aLevel) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLevel(aLevel); } \
  NS_IMETHOD SetLevel(PRUint32 aLevel) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLevel(aLevel); } \
  NS_IMETHOD SetCurrentRepeat(nsIXFormsRepeatElement *aCurrentRepeat, PRUint32 aIndex) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetCurrentRepeat(aCurrentRepeat, aIndex); } \
  NS_IMETHOD GetCurrentRepeatRow(nsIDOMNode **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCurrentRepeatRow(_retval); } \
  NS_IMETHOD AddIndexUser(nsIXFormsControl *aControl) { return !_to ? NS_ERROR_NULL_POINTER : _to->AddIndexUser(aControl); } \
  NS_IMETHOD RemoveIndexUser(nsIXFormsControl *aControl) { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveIndexUser(aControl); } \
  NS_IMETHOD IndexHasChanged(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->IndexHasChanged(); } \
  NS_IMETHOD GetStartingIndex(PRUint32 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStartingIndex(_retval); } \
  NS_IMETHOD HandleNodeInsert(nsIDOMNode *node) { return !_to ? NS_ERROR_NULL_POINTER : _to->HandleNodeInsert(node); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsXFormsRepeatElement : public nsIXFormsRepeatElement
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIXFORMSREPEATELEMENT

  nsXFormsRepeatElement();

private:
  ~nsXFormsRepeatElement();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsXFormsRepeatElement, nsIXFormsRepeatElement)

nsXFormsRepeatElement::nsXFormsRepeatElement()
{
  /* member initializers and constructor code */
}

nsXFormsRepeatElement::~nsXFormsRepeatElement()
{
  /* destructor code */
}

/* void setIndex (inout unsigned long aIndex, in boolean aIsRefresh); */
NS_IMETHODIMP nsXFormsRepeatElement::SetIndex(PRUint32 *aIndex, PRBool aIsRefresh)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned long index; */
NS_IMETHODIMP nsXFormsRepeatElement::GetIndex(PRUint32 *aIndex)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void deselect (); */
NS_IMETHODIMP nsXFormsRepeatElement::Deselect()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute boolean isParent; */
NS_IMETHODIMP nsXFormsRepeatElement::GetIsParent(PRBool *aIsParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsXFormsRepeatElement::SetIsParent(PRBool aIsParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIXFormsRepeatElement parent; */
NS_IMETHODIMP nsXFormsRepeatElement::GetParent(nsIXFormsRepeatElement * *aParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsXFormsRepeatElement::SetParent(nsIXFormsRepeatElement * aParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute unsigned long level; */
NS_IMETHODIMP nsXFormsRepeatElement::GetLevel(PRUint32 *aLevel)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsXFormsRepeatElement::SetLevel(PRUint32 aLevel)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setCurrentRepeat (in nsIXFormsRepeatElement aCurrentRepeat, in unsigned long aIndex); */
NS_IMETHODIMP nsXFormsRepeatElement::SetCurrentRepeat(nsIXFormsRepeatElement *aCurrentRepeat, PRUint32 aIndex)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIDOMNode getCurrentRepeatRow (); */
NS_IMETHODIMP nsXFormsRepeatElement::GetCurrentRepeatRow(nsIDOMNode **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void addIndexUser (in nsIXFormsControl aControl); */
NS_IMETHODIMP nsXFormsRepeatElement::AddIndexUser(nsIXFormsControl *aControl)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void removeIndexUser (in nsIXFormsControl aControl); */
NS_IMETHODIMP nsXFormsRepeatElement::RemoveIndexUser(nsIXFormsControl *aControl)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void indexHasChanged (); */
NS_IMETHODIMP nsXFormsRepeatElement::IndexHasChanged()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* unsigned long getStartingIndex (); */
NS_IMETHODIMP nsXFormsRepeatElement::GetStartingIndex(PRUint32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void handleNodeInsert (in nsIDOMNode node); */
NS_IMETHODIMP nsXFormsRepeatElement::HandleNodeInsert(nsIDOMNode *node)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIXFormsRepeatElement_h__ */
