/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIXFormsUIWidget.idl
 */

#ifndef __gen_nsIXFormsUIWidget_h__
#define __gen_nsIXFormsUIWidget_h__


#ifndef __gen_nsIDOMElement_h__
#include "nsIDOMElement.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif

/* starting interface:    nsIXFormsUIWidget */
#define NS_IXFORMSUIWIDGET_IID_STR "f636007c-cc01-4295-b3cb-d525054c4a14"

#define NS_IXFORMSUIWIDGET_IID \
  {0xf636007c, 0xcc01, 0x4295, \
    { 0xb3, 0xcb, 0xd5, 0x25, 0x05, 0x4c, 0x4a, 0x14 }}

/**
 * Interface implemented by XForms UI widgets.
 *
 * For more information on this interface please see
 * http://developer.mozilla.org/en/docs/XForms:Custom_Controls
 *
 */
class NS_NO_VTABLE nsIXFormsUIWidget : public nsIDOMElement {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IXFORMSUIWIDGET_IID)

  /**
   * Called, when UI Widget should refresh itself.
   */
  /* void refresh (); */
  NS_IMETHOD Refresh(void) = 0;

  /**
   * Tries to focus the UI Widget. Returns true, if focusing succeeded.
   */
  /* boolean focus (); */
  NS_IMETHOD Focus(PRBool *_retval) = 0;

  /**
   * During submission, the \<submit\> should be disabled.
   */
  /* void disable (in boolean disable); */
  NS_IMETHOD Disable(PRBool disable) = 0;

  /**
   * Return "string" value of xforms element that element actually shows.
   *
   * From time to time current element value can be different from current value
   * of instance node that element is bound to. For example:
   * 1) When a XForms control has non-incremental update and its value is
   * changed due to user interaction, then getCurrentValue will return the
   * control's new value even though the bound node has not been updated yet.
   * 2) If instace value is out of range then xforms element can't show it.
   * Therefore it shows default value and getCurrentValue will return showed
   * value.
   */
  /* AString getCurrentValue (); */
  NS_IMETHOD GetCurrentValue(nsAString & _retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIXFORMSUIWIDGET \
  NS_IMETHOD Refresh(void); \
  NS_IMETHOD Focus(PRBool *_retval); \
  NS_IMETHOD Disable(PRBool disable); \
  NS_IMETHOD GetCurrentValue(nsAString & _retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIXFORMSUIWIDGET(_to) \
  NS_IMETHOD Refresh(void) { return _to Refresh(); } \
  NS_IMETHOD Focus(PRBool *_retval) { return _to Focus(_retval); } \
  NS_IMETHOD Disable(PRBool disable) { return _to Disable(disable); } \
  NS_IMETHOD GetCurrentValue(nsAString & _retval) { return _to GetCurrentValue(_retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIXFORMSUIWIDGET(_to) \
  NS_IMETHOD Refresh(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Refresh(); } \
  NS_IMETHOD Focus(PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->Focus(_retval); } \
  NS_IMETHOD Disable(PRBool disable) { return !_to ? NS_ERROR_NULL_POINTER : _to->Disable(disable); } \
  NS_IMETHOD GetCurrentValue(nsAString & _retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCurrentValue(_retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsXFormsUIWidget : public nsIXFormsUIWidget
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIXFORMSUIWIDGET

  nsXFormsUIWidget();

private:
  ~nsXFormsUIWidget();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsXFormsUIWidget, nsIXFormsUIWidget)

nsXFormsUIWidget::nsXFormsUIWidget()
{
  /* member initializers and constructor code */
}

nsXFormsUIWidget::~nsXFormsUIWidget()
{
  /* destructor code */
}

/* void refresh (); */
NS_IMETHODIMP nsXFormsUIWidget::Refresh()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean focus (); */
NS_IMETHODIMP nsXFormsUIWidget::Focus(PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void disable (in boolean disable); */
NS_IMETHODIMP nsXFormsUIWidget::Disable(PRBool disable)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* AString getCurrentValue (); */
NS_IMETHODIMP nsXFormsUIWidget::GetCurrentValue(nsAString & _retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIXFormsUIWidget_h__ */
